﻿using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace Chocoat
{
    /// <summary>
    /// CHOCOAからのイベントを受け取るためのインターフェイス
    /// </summary>
    [ComImport, Guid("432ED2D0-2057-11D2-903A-00000E7C45FA"), TypeLibType((short)0x1000), InterfaceType((short)2)]
    internal interface IChocoaEvents
    {
        [PreserveSig, MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime), DispId(1)]
        void MessageEvent([MarshalAs(UnmanagedType.BStr)] string SettingNM, [MarshalAs(UnmanagedType.BStr)] string Channel, [MarshalAs(UnmanagedType.BStr)] string Nick, [MarshalAs(UnmanagedType.BStr)] string Address, short MessageType, [MarshalAs(UnmanagedType.BStr)] string Message);

        [PreserveSig, MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime), DispId(2)]
        void CTCPMessageEvent([MarshalAs(UnmanagedType.BStr)] string SettingNM, [MarshalAs(UnmanagedType.BStr)] string Channel, [MarshalAs(UnmanagedType.BStr)] string Nick, [MarshalAs(UnmanagedType.BStr)] string Address, short MessageType, [MarshalAs(UnmanagedType.BStr)] string Message);

        [PreserveSig, MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime), DispId(3)]
        void IRCEvent([MarshalAs(UnmanagedType.BStr)] string SettingNM, int MessageType, [MarshalAs(UnmanagedType.BStr)] string ReValue);

        [PreserveSig, MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime), DispId(4)]
        void ScriptEvent([MarshalAs(UnmanagedType.BStr)] string SettingNM, short EventType, [MarshalAs(UnmanagedType.BStr)] string ServiceNM, [MarshalAs(UnmanagedType.BStr)] string FuncNM, [MarshalAs(UnmanagedType.BStr)] string ReValue);

        [PreserveSig, MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime), DispId(5)]
        void NumericMessageEvent([MarshalAs(UnmanagedType.BStr)] string SettingNM, int Numeric, [MarshalAs(UnmanagedType.BStr)] string Message);

        [PreserveSig, MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime), DispId(6)]
        void ChocoaEvent([MarshalAs(UnmanagedType.BStr)] string SettingNM, [MarshalAs(UnmanagedType.BStr)] string tp, [MarshalAs(UnmanagedType.Struct)] object vaData);
    }
}
