﻿using System;

namespace Chocoat
{
    /// <summary>
    /// IRCイベントを受信した際の情報を提供するイベントデータの基底です。
    /// </summary>
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709:IdentifiersShouldBeCasedCorrectly", MessageId = "IRC")]
    public abstract class IRCEventArgs : EventArgs
    {
        /// <summary>
        /// IRCEventArgs のインスタンスは生成出来ません。
        /// </summary>
        /// <param name="settingServerName">サーバー設定名</param>
        protected internal IRCEventArgs(string settingServerName)
        {
            this.SettingServerName = settingServerName;
        }

        /// <summary>
        /// サーバー設定名を取得します。
        /// </summary>
        public string SettingServerName { get; private set; }
    }
}
