﻿using System;

namespace DoubleX3rd
{
    /// <summary>
    /// ダイスロール変更のイベント
    /// </summary>
    public sealed class DiceRollChangedEventArgs : EventArgs
    {
        /// <summary>
        /// DiceRollChangedEventArgs の新しいインスタンスを生成します。
        /// </summary>
        /// <param name="diceRoll">変更されたダイスロール</param>
        public DiceRollChangedEventArgs(DiceRoll diceRoll)
        {
            this.DiceRoll = diceRoll;
        }

        /// <summary>
        /// 変更された新しいダイスロールを取得します。
        /// </summary>
        public DiceRoll DiceRoll { get; private set; }
    }
}
