﻿using System;

namespace DoubleX3rd
{
    /// <summary>
    /// 侵蝕値の変更イベント
    /// </summary>
    public sealed class ErosionRateChangedEventArgs : EventArgs
    {
        /// <summary>
        /// ErosionRateChangedEventArgs の新しいインスタンスを生成します。
        /// </summary>
        /// <param name="erosionRate">侵蝕値</param>
        public ErosionRateChangedEventArgs(int erosionRate)
        {
            this.ErosionRate = erosionRate;
        }

        /// <summary>
        /// 変更された新しい侵蝕値を取得します。
        /// </summary>
        public int ErosionRate { get; private set; }
    }
}
