﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            foreach (string name in this.chocoatComponents1.GetSettingServerNames())
            {
                this.lstSettingServers.Items.Add(name);
            }

            foreach (string name in this.chocoatComponents1.GetConnectedServerList())
            {
                this.lstConnectedServer.Items.Add(name);
            }
        }

        private void lstConnectedServer_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.lstConnectedServer.SelectedIndex != -1)
            {
                string name = (string)this.lstConnectedServer.Items[this.lstConnectedServer.SelectedIndex];
                int serverID = this.chocoatComponents1.FindServerID(name);

                foreach (string channel in this.chocoatComponents1.GetChannelList(serverID))
                {
                    this.lstChannel.Items.Add(channel);
                }
            }
        }

        delegate void SetMessage(Chocoat.MessageEventArgs e); 

        /// <summary>
        /// イベントのメッセージをつかまえるとこです。
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void chocoatComponents1_MessageEvent(object sender, Chocoat.MessageEventArgs e)
        {
            if (this.InvokeRequired)
            {
                this.Invoke(new SetMessage(SetText), e);
            }
            else
            {
                this.SetText(e);
            }
        }

        private void SetText(Chocoat.MessageEventArgs e)
        {
            if (this.lstMessage.Items.Count > 100)
            {
                this.lstMessage.Items.RemoveAt(0);
            }

            this.lstMessage.SelectedIndex = this.lstMessage.Items.Add(String.Format("<{0}> {1}", e.Nick, e.Message)) - 1;
        }

        private void btnSendMessage_Click(object sender, EventArgs e)
        {
            if (this.txtMessage.TextLength > 0 &&
                this.lstConnectedServer.SelectedIndex != -1 &&
                this.lstChannel.SelectedIndex != -1)
            {
                string serverName = (string)this.lstConnectedServer.Items[this.lstConnectedServer.SelectedIndex];
                int serverID = this.chocoatComponents1.FindServerID(serverName);

                string channel = (string)this.lstChannel.Items[this.lstChannel.SelectedIndex];

                this.chocoatComponents1.SendPrivateMessage(serverID, channel, this.txtMessage.Text);

                this.txtMessage.Text = String.Empty;
            }
        }

        private void chocoatComponents1_IRCActionEvent(object sender, Chocoat.IRCActionEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCActionEvent", e));
        }

        private void chocoatComponents1_IRCInviteEvent(object sender, Chocoat.IRCInviteEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCInviteEvent", e));
        }

        private void chocoatComponents1_IRCIsonEvent(object sender, Chocoat.IRCIsonEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCIsonEvent", e));
        }

        private void chocoatComponents1_IRCJoinEvent(object sender, Chocoat.IRCJoinEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCJoinEvent", e));
        }

        private void chocoatComponents1_IRCKickEvent(object sender, Chocoat.IRCKickEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCKickEvent", e));
        }

        private void chocoatComponents1_IRCModeEvent(object sender, Chocoat.IRCModeEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCModeEvent", e));
        }

        private void chocoatComponents1_IRCNamesEvent(object sender, Chocoat.IRCNamesEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCNamesEvent", e));
        }

        private void chocoatComponents1_IRCNickEvent(object sender, Chocoat.IRCNickEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCNickEvent", e));
        }

        private void chocoatComponents1_IRCPartEvent(object sender, Chocoat.IRCPartEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCPartEvent", e));
        }

        private void chocoatComponents1_IRCQuitEvent(object sender, Chocoat.IRCQuitEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCQuitEvent", e));
        }

        private void chocoatComponents1_IRCTopicEvent(object sender, Chocoat.IRCTopicEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCTopicEvent", e));
        }

        private void chocoatComponents1_IRCWhoEvent(object sender, Chocoat.IRCWhoEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCWhoEvent", e));
        }

        private void chocoatComponents1_IRCWhoisEvent(object sender, Chocoat.IRCWhoisEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_IRCWhoisEvent", e));
        }

        private void chocoatComponents1_ChocoaWindowEvent(object sender, Chocoat.ChocoaWindowEventArgs e)
        {
            Debug.WriteLine(String.Format("{0}:{1}", "chocoatComponents1_ChocoaWindowEvent", e));
        }

      

        private void button1_Click(object sender, EventArgs e)
        {
            Chocoat.Utility.UPnP p = new Chocoat.Utility.UPnP();

            MessageBox.Show(p.AddTcpPortMapping(6500, 0, "Test").ToString());

            //foreach (Chocoat.Utility.UPnP.AddressPair pair in Chocoat.Utility.UPnP.Get())
            //{
            //    Console.WriteLine(pair);
            //}
            //Chocoat.Utility.TcpTable p = Chocoat.Utility.TcpTable.GetTcpTable();
            //foreach (Chocoat.Utility.TcpRow row in p)
            //{
            //    this.lstChannel.Items.Add(row);
            //}

            //Chocoat.Utility.UPnP.OpenPort(6500);
//                    string scriptName = "CHOCOAT_GET_NICK";
//            string nickScript = String.Format(@"/{0}
//{{
//    /comresult $me
//}}", scriptName);

//            string result = null;

//            this.chocoatComponents1.RegisterScriptFunction(1, nickScript, out serviceName);
            
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Chocoat.Utility.UPnP p = new Chocoat.Utility.UPnP();
            p.GetPortMapping();
        }

       

       
    }
}
